<?php
class appFurgonetkaBackendActions extends autoAppFurgonetkaBackendActions
{

    public function executeIndex(){
        return $this->redirect('appFurgonetkaBackend/config');
    }

    public function executeConfig(){

        $this->user = $this->checkUser();

        $this->processConfigForwardParameters();
        
        $this->hideable = $this->getConfigHideable();
        
        $this->loadViewFields($this->hideable, 'config');
        
        $i18n = $this->getContext()->getI18N();
        
        $this->related_object = null;
  
        $this->config = $this->loadConfigOrCreate();
        
        $this->labels = $this->getConfigLabels();
        
        if ($this->getRequest()->getMethod() == sfRequest::POST) {  

            $config = $this->getRequestParameter('config');


            if (!$this->getRequest()->hasErrors()){

             $sf_guard_user = new sfGuardUser();

             $sf_guard_user->setIsActive(1);

             $sf_guard_user->setUsername($config['username']);

             $sf_guard_user->setPassword($config['password']);

             $sf_guard_user->setFurgonetka(1);

             $sf_guard_user->save();

             $c = new Criteria();

             $c->add(sfGuardUserPeer::FURGONETKA, 1);

             $user = sfGuardUserPeer::doSelectOne($c);

             $user_group = new sfGuardUserGroup();

             $user_group->setUserId($user->getId());

             $user_group->setGroupId(1);

             $user_group->save();

             $user_perm = new sfGuardUserPermission();

             $user_perm->setUserId($user->getId());

             $user_perm->setPermissionId(5);

             $user_perm->save();

             $user_perm = new sfGuardUserPermission();

             $user_perm->setUserId($user->getId());

             $user_perm->setPermissionId(6);

             $user_perm->save();

              if (!$this->hasFlash('success') && !$this->hasFlash('error') && !$this->getRequest()->hasErrors())
              {
                $this->setFlash('success', $i18n->__('Twoje zmiany zostały zapisane', null, 'stAdminGeneratorPlugin'));
              }
              
              if (!$this->getRequest()->hasErrors())
              {
                return $this->redirect('appFurgonetkaBackend/config?culture='.$this->config->getCulture());
              }
            }



        } 

        $this->addWebapiWarning();

        $this->addInfo();

        $this->getBreadcrumbsBuilder()->getDefaultBreadcrumbs()->add($i18n->__('Konfiguracja', null, 'appFurgonetkaBackend'));
      }  


        public function handleErrorConfig(){

            $this->addWebapiWarning();

            $this->addInfo();        

            return parent::handleErrorConfig();
        
        }

        private function addWebapiWarning(){
            
            $config_webapi = stConfig::getInstance(sfContext::getInstance(), 'stWebApiBackend');

            if ($config_webapi->get('webapi_on')!=1){

                $this->setFlash('warning', 'Włącz możliwość połączenia ze sklepem za pomocą WebApi <a href="/backend.php/webapi/config" target="_blank" rel="noopener, noreferrer">tutaj</a>.', false);

             }

        }

      private function addInfo(){

        $c = new Criteria();

        $check = $this->checkUser();

        if(!$check){

        $this->setFlash('info', 'Dodaj użytkownika Webapi, który będzie łączył się ze sklepem od strony serwisu <a href="https://furgonetka.pl" target="_blank" rel="noopener, noreferrer">Furgonetka.pl</a>.', false);

        } 

      }

      private function checkUser(){

         $c = new Criteria();

         $c->add(sfGuardUserPeer::FURGONETKA, 1);

         $user = sfGuardUserPeer::doSelectOne($c);

         if ($user){

          return $user;
        
        }else{
        
          return 0;
        
        }

      }

       public function executeDelete(){

       $c = new Criteria();

       $c->add(sfGuardUserPeer::FURGONETKA, 1);

        $user = sfGuardUserPeer::doSelectOne($c);
         
        if($user){
         
         $user->delete();
         
        }

         return $this->redirect('appFurgonetkaBackend/config');
       }

}
